#include <Servo.h>
#include <Wire.h> 
#include <LiquidCrystal_I2C.h>

int trig = 2;
int echo = 3;

int btn = 6;

int redpin = 11;
int greenpin = 10;
int bluepin = 9;

int yled = 5;
int ldr = A0;

long duration, inches;
Servo myServo;
LiquidCrystal_I2C lcd(0x27,16,2);

void setup() {
  pinMode(trig, OUTPUT);
  pinMode(yled, OUTPUT);
  pinMode(redpin, OUTPUT);
  pinMode(greenpin, OUTPUT);
  pinMode(bluepin, OUTPUT);
  
  pinMode(echo, INPUT);
  pinMode(btn, INPUT);

  lcd.init();  //initialize the lcd
  lcd.backlight();  //open the backlight 
  myServo.attach(12);
  
  Serial.begin(9600);

}

void loop() {
  distance();
  distanceColour();
  screen();
  light();
  lock();

}



void distance(){
  digitalWrite(trig, LOW);
  delayMicroseconds(2);
  digitalWrite(trig, HIGH);
  delayMicroseconds(10);
  digitalWrite(trig, LOW);

  duration = pulseIn(echo, HIGH);
  inches = duration/74/2;
  Serial.println(inches);
}

void screen(){
  
  lcd.setCursor(4,0);  // set the cursor to column 0, line 0
  lcd.print("Distance:");
  delay(1000);
  lcd.setCursor(7,1);
  lcd.print(inches);
  delay(1000);
  lcd.clear();  //Clears the LCD screen and positions the cursor in the upper-left corner.
  //delay(1000);
}

void setColor (int red, int green, int blue)
{

  red = 255 - red;
  green = 225- green;
  blue = 255 - blue;
  analogWrite (redpin, red);
  analogWrite (greenpin, green);
  analogWrite (bluepin, blue);
}

void distanceColour(){
 if (inches<=5)
    setColor(255,0,0);//red

  else if (inches<=15 && inches>=6)
    setColor(0, 0, 255);//blue
    
  else
    setColor(0,255,0);//green
}

void light(){
   if (analogRead(ldr)<500)
     digitalWrite(yled, HIGH);
  else
     digitalWrite(yled,LOW);
}

void lock(){
  if (digitalRead(btn) == HIGH)
  {
    myServo.write(40);
    delay(1000);
    myServo.write(125);
  }
  else 
   myServo.write(40);
}



